////////////////////////////////////////////
// File buffer_queue.c: Object Implementation

#include "buffer_queue.h"

int queue_head=0; 
int queue_tail=MAX_DATA-1;
char queue_item[MAX_DATA];

int queue_isfull(void)
{
   return (queue_tail+2) % MAX_DATA == queue_head;
}

int queue_isempty(void)
{
   return (queue_tail+1) % MAX_DATA == queue_head;
}


int  queue_insert (const char *message)
{
     if (queue_isfull()) {
          return ERROR;
     } else {
         queue_tail=(queue_tail+1) % MAX_DATA;
         queue_item[queue_tail]=*message;
         return 0;
     }
}

int queue_extract (char *message)
{
     if (queue_isempty()) {
         return ERROR;
     } else {
         *message=queue_item[queue_head];
         queue_head=(queue_head+1) % MAX_DATA;
         return 0;
     }
}
